/**
   chat: a TCP/IP chatting program
   Copyright (C) 2006  Idan Nof

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License
   as published by the Free Software Foundation; either version 2
   of the License, or (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   Idan Nof can be reached via -

   email: idannof (at) hotmail (dot) com
   web  : http://www.geocities.com/idannof
   paper: 3 Brande st.,
		  Petach-Tikva, 49600,
		  Israel
*/
/*
 * Created on 12/02/2006
 */
package Client;

/**
 * A class that represents a thread that can be requested to stop.
 * 
 * It is vital that inheriting classes will poll on stopRequested() variable for
 * stop requests, to implement that functionality.
 */
public class StoppableThread extends Thread {
	/**
	 * predicate for stop requestes.
	 */
	private boolean stopRequested = false;

	/**
	 * Request a stop.
	 */
	public synchronized void requestStop(Object o) {
		stopRequested = true;
		System.out.println("Stop request detected from " + o);
	}

	/**
	 * A predicate method that returns whether stop has been requested
	 * @return True if stop has been requested
	 */
	public synchronized boolean stopRequested() {
		return stopRequested;
	}
}
